// File: Operator.java
// Create and run some threads
// Need 2 classes here, a thread class and a main class
//      Each thread will initialize and start its successor
//      The last thread will print the final message
//
// Note that there are no throws clauses because every possible exception is caught

import java.io.*;

class Participant extends Thread
{private int number;
 private String Message;

 // Constructor: Get sleep duration and print it
 public Participant(String Name,String theMessage)
 {super(Name);
  // Announce thread number and # milliseconds it will sleep
  number=Integer.valueOf(getName()).intValue();
  Message=theMessage;
 }

 // run() executes when the thread is started
 public void run()
 {  System.out.println("Thread "+getName()+ " got message "+Message);
  // Need to change a random character of the message to a random char
  int spot=(int)(Math.random()*Message.length()); // Pick a spot in the String
  char[] temp=Message.toCharArray();   // Convert to char array
  char hold=temp[spot];
  temp[spot]=(char)((Math.random()*128)); // Pick random char
  System.out.println("Spot:"+spot+" Char "+hold+" becomes "+temp[spot]);
  if (--number>0) { // Create a Participant thread and let it loose
     Participant nextThread=
         new Participant(String.valueOf(number),String.valueOf(temp));
     try {
         sleep(50);
     }
     catch (Exception e) {}
     nextThread.start();
  }
  else  // Print the final message
    try {
        System.out.println("Final version of message is:"+Message);
        System.out.println("Press any key to quit");
        System.in.read();
    }
    catch (Exception e) {}
 } // run

} // class


public class Operator {

static BufferedReader DataIn = new
			    BufferedReader(new InputStreamReader(System.in));

 static int ReadInt() throws java.io.IOException
 {String Input=DataIn.readLine();
  return (Integer.valueOf(Input).intValue());
 }

 public static void main(String[] args)
 {int numberOfThreads=0;
  // Get number of threads to test
  try {
   System.out.print("How many participants?  >");
   numberOfThreads=ReadInt();
  }
  catch (Exception e) {
   System.out.println("Exception:"+e.toString());
  }
  // Get Message
  String Message="";
  try {
   System.out.print("Enter a Message  >");
   Message=DataIn.readLine();
  }
  catch (Exception e) {
   System.out.println("Exception:"+e.toString());
  }
  // Declare first thread
  Participant It=new Participant(String.valueOf(numberOfThreads),Message);
  // Start the first thread
  It.start();
 } // main

} // main class

